Subject: Re: [PATCH mlx5-next v2 0/5] Dynamically assign MSI-X vectors count

From: Leon Romanovsky <[email-masked]>
Date: Tue, 19 Jan 2021 07:39:31 +0200

On Mon, Jan 18, 2021 at 10:07:32AM -0800, Jakub Kicinski wrote:
> On Sun, 17 Jan 2021 09:24:41 +0200 Leon Romanovsky wrote:
> > On Sun, Jan 17, 2021 at 07:44:09AM +0200, Leon Romanovsky wrote:
> > > On Thu, Jan 14, 2021 at 09:51:28AM -0800, Jakub Kicinski wrote:
> > > > On Thu, 14 Jan 2021 12:31:35 +0200 Leon Romanovsky wrote:
> > > > > The number of MSI-X vectors is PCI property visible through lspci, that
> > > > > field is read-only and configured by the device.
> > > > >
> > > > > The static assignment of an amount of MSI-X vectors doesn't allow utilize
> > > > > the newly created VF because it is not known to the device the future load
> > > > > and configuration where that VF will be used.
> > > > >
> > > > > The VFs are created on the hypervisor and forwarded to the VMs that have
> > > > > different properties (for example number of CPUs).
> > > > >
> > > > > To overcome the inefficiency in the spread of such MSI-X vectors, we
> > > > > allow the kernel to instruct the device with the needed number of such
> > > > > vectors, before VF is initialized and bounded to the driver.
> > > >
> > > >
> > > > Hi Leon!
> > > >
> > > > Looks like you got some missing kdoc here, check out the test in
> > > > patchwork so we don't need to worry about this later:
> > > >
> > > > https://patchwork.kernel.org/project/netdevbpf/list/?series=414497
> > >
> > > Thanks Jakub,
> > >
> > > I'll add kdocs to internal mlx5 functions.
> > > IMHO, they are useless.
>
> It's just scripts/kernel-doc, and it's checking if the kdoc is _valid_,
> your call if you want to add kdoc, just a comment, or nothing at all.

I prefer clean CI, so will add.

>
> > At the end, it looks like CI false alarm.
> >
> > drivers/net/ethernet/mellanox/mlx5/core/pci_irq.c:81: warning: Function parameter or member 'dev' not described in 'mlx5_set_msix_vec_count'
> > drivers/net/ethernet/mellanox/mlx5/core/pci_irq.c:81: warning: Function parameter or member 'function_id' not described in 'mlx5_set_msix_vec_count'
> > drivers/net/ethernet/mellanox/mlx5/core/pci_irq.c:81: warning: Function parameter or member 'msix_vec_count' not described in 'mlx5_set_msix_vec_count'
> > New warnings added
> >
> > The function mlx5_set_msix_vec_count() is documented.
> > +/**
> > + * mlx5_set_msix_vec_count() - Set dynamically allocated MSI-X to the VF
> > + * @dev - PF to work on
> > + * @function_id - internal PCI VF function id
> > + * @msix_vec_count - Number of MSI-X to set
> > + **/
> > +int mlx5_set_msix_vec_count(struct mlx5_core_dev *dev, int function_id,
> > +			    int msix_vec_count)
> > https://patchwork.kernel.org/project/netdevbpf/patch/[email-masked]/
>
> AFAIU that's not valid kdoc, I _think_ you need to replace ' -' with ':'
> for arguments (not my rules).

Right, I figured it when submitted v3.

Thanks